IMPLEMENTATION MODULE Utils;

IMPORT Types, SO, Str, Clock;

TYPE
  LC = Types.TLngCard;

TYPE
  TAdrIdx = [ 0 .. 3 ];
  TAdrRec = RECORD
    CASE : CARDINAL OF
    | 0: b: ARRAY TAdrIdx OF Types.TShtCard;
    | 1: l: Types.TLngCard;
    END;
  END;


PROCEDURE IP( a, b, c, d: Types.TShtCard ): Types.TLngCard;
BEGIN
  RETURN LC( a ) + LC( b ) * 100H + LC( c ) * 10000H + LC( d ) * 1000000H;
END IP;

PROCEDURE MkIP( VAR ip: Types.TLngCard; str-: ARRAY OF CHAR ): BOOLEAN;
VAR
  i: TAdrIdx;
  r: TAdrRec;
  s: TIPStr;
  x: Types.TLngCard;
  ok, ok1: BOOLEAN;
BEGIN
  ok := TRUE;
  FOR i := MIN(TAdrIdx) TO MAX(TAdrIdx) DO
    Str.ItemS( s, str, '.', i );
    x := Str.StrToCard( s, 10, ok1 );
    r.b[i] := Types.TShtCard( x MOD 100H);
    ok := ok & ok1 & ( x < 100H );
  END;
  IF ok THEN ip := r.l END;
  RETURN ok;
END MkIP;

PROCEDURE WrIP( VAR b: SO.TBuffer; ip: Types.TLngCard );
VAR
  i: TAdrIdx;
  r: TAdrRec;
BEGIN
  r.l := ip;
  FOR i := MIN(TAdrIdx) TO MAX(TAdrIdx) DO
    SO.WrShtCard( b, r.b[i], 1 );
    IF i < MAX(TAdrIdx) THEN SO.WrChar( b, '.' ) END;
  END;
END WrIP;

PROCEDURE WrDate( VAR b: SO.TBuffer; date: Types.TCard );
VAR
  y, m, d: CARDINAL;
  pc: CHAR;
BEGIN
  Clock.UnpackDate( date, y, m, d );
  pc := b.c.p;
  b.c.p := '0';
  SO.WrCard( b, y, 4 );
  SO.WrCard( b, m, 2 );
  SO.WrCard( b, d, 2 );
  b.c.p := pc;
END WrDate;

PROCEDURE WrTime( VAR b: SO.TBuffer; time: Types.TLngCard );
VAR
  h, m, s, f: CARDINAL;
  pc: CHAR;
BEGIN
  Clock.UnpackTime( time, h, m, s, f );
  pc := b.c.p;
  b.c.p := '0';
  SO.WrCard( b, h, 2 );
  SO.WrCard( b, m, 2 );
  SO.WrCard( b, s, 2 );
  SO.WrChar( b, '.' );
  SO.WrCard( b, f, 3 );
  b.c.p := pc;
END WrTime;

PROCEDURE WrDateTime( VAR b: SO.TBuffer; d: Types.TCard; t: Types.TLngCard );
BEGIN
  WrDate( b, d );
  SO.WrChar( b, '_' );
  WrTime( b, t );
END WrDateTime;

END Utils.
